
#include "config.h"

extern int cho;
extern int qnum;
extern int argc;
extern char **argv;
extern char version[10];
extern char comp_time[30];
extern char quote[1500];
extern FILE *pql;

void no_arg()
{
    open_lib();
    read_info();
    read_current_quote();
    close_lib();
    cut_into_words();
    get_author();
    get_contrib();
    show_quote();    
    exit(0);
}

void arg_help(int i,int argc,char **argv)
{
    open_lib();
    read_info();
    close_lib();
    printf("\nPortable Easy Quote (PEQ) v%s\n",version);
    printf("Main coder: Alex 'Dabugas' Armstrong (dabugas@usa.net)\n");
    printf("Includes code by: Kimon 'Hellraiser' Kodosis (kimon.k@usa.net)\n");
    printf("Special thanks to all the people who supported us and all quote contributions.\n");
    printf("Released under the GPL license (see the LICENSE file)\n");
    printf("usage: peq <options>\n");
    printf("options:\n");
    printf("--help\t\t\tDisplays this help message (well, duh...)\n");
    printf("--quote <num>\t\tDisplays quote number <num>\n");
    printf("--search <keyword>\tSearches for keywords <keyword>\n\t\t\t(only one keyword is supportec currently...)\n");	    
//  printf("--title <name>\tAlong with the quote display a title-thingy\n");
//  printf("\t\tPossible titles names are: default sign\n");
    printf("Running the program without any options randomly displays a quote.\n\n");
    printf("The PEQ Quote Library (peq.lib) is dated: %s GMT, and\n",comp_time);
    printf("contains the vast amount of %d quotes.\n",qnum);
    printf("Get a newer version at http://saint.simplenet.com/rope/peq.html\n");
    printf("For quote submissions send e-mail to dabugas@usa.net\n\n");
    exit(0);
}

void arg_quote(int i,int argc,char **argv)
{
    i++;
    if(i>argc-1)
    {
	printf("peq: not enough parameters\n");
	exit(1);
    }
    if(i<=argc-1)
    {
	open_lib();
	read_info();
	if((int)atof(argv[i])<=qnum)
	{
	    cho=(int)atof(argv[i])+2;
	    read_current_quote();
	    close_lib();	    
	    cut_into_words();
	    get_author();
	    get_contrib();
	    show_quote();
	}
	else
	{
	    printf("peq: there are only %d quotes\n",qnum);
	    exit(1);
	}
    }
}

// This is pretty badly programmed, but I since it works I'll leave it for now.
// It _has_ worked on all situations I've thrown at it, so I remain optimistic!
void arg_search(int i, int argc, char **argv)
{
    i++;
    if(i>argc-1)
    {
	printf("peq: not enough parameters\n");
	exit(1);
    }
    if(i<=argc-1)
    {
	open_lib();
	read_info();
	fseek(pql,0,SEEK_SET);
	char read[1500];
	int matches=0;
	int bcho=0;
	long j=0;
	long pqlsize=fsize(pql);
	cho=2;
	printf("\nSearching peq.lib...\n");
	while(j<pqlsize)
	{
	    fseek(pql,j,SEEK_SET);
	    fgets(read,strlen(argv[i])+1,pql);
	    if(strcmp(read,"\n")==0)
	    {
		cho++;
	    }	  
	    if(strcasecmp(argv[i],read)==0 && cho!=bcho)
	    {
		fseek(pql,0,SEEK_SET);
		printf("\n--> Quote number %d...\n",cho-2);
		read_current_quote();
		cut_into_words();
		get_author();
		get_contrib();
		show_quote();
		clear_vars();
	    	matches++;
		bcho=cho;
	    }
	    j++;
	}
	printf("\nSearched through %d quotes and found %d matches\n",qnum,matches);
	close_lib();
	exit(0);
    }
}

/*
void arg_title(int i, int argc, char **argv)
{
    i++;
    if(i>argc-1)
    {
	printf("peq: not enough parameters\n");
	exit(1);
    }
    if(i<=argc-1)
    {
	open_lib();
	read_info();
	read_current_quote();
	close_lib();	    
	cut_into_words();
	get_author();
	if(strcmp(argv[i],"default")==0)
	{
	    printf("Portable Easy Quote (PEQ) v%s - Quote %d / %d\n",version,cho,qnum);
	    printf("--------------------------------------------------------------------------------\n");
	    show_quote();
	    exit(0);
	}
	if(strcmp(argv[i],"sign")==0)
	{
	    printf("/------------------------------------------------------------------------------\\\n");
	    show_quote();
	    printf("\\------------------------------------------------------------------------------/\n");
	    exit(0);
	}
	printf("peq: no valid title\n");
	exit(1);
    }
}
*/
